package com.steerinfo.ems.emsproductsexecutivestandard.controller;

import com.steerinfo.auth.utils.JwtUtil;
import com.steerinfo.ems.emsproductsexecutivestandard.model.EmsProductsExecutiveStandard;
import com.steerinfo.ems.emsproductsexecutivestandard.service.IEmsProductsExecutiveStandardService;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

/**
 * EmsProductsExecutiveStandard RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-03-25 02:05
 * 类描述
 * 修订历史：
 * 日期：2022-03-25
 * 作者：generator
 * 参考：
 * 描述：EmsProductsExecutiveStandard RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/emsproductsexecutivestandards")
public class EmsProductsExecutiveStandardController extends BaseRESTfulController {

    @Autowired
    IEmsProductsExecutiveStandardService emsProductsExecutiveStandardService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("emsproductsexecutivestandard:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<EmsProductsExecutiveStandard> list = emsProductsExecutiveStandardService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("emsproductsexecutivestandard:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<EmsProductsExecutiveStandard> list = emsProductsExecutiveStandardService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据EmsProductsExecutiveStandard对象创建")
    @ApiImplicitParam(name = "emsProductsExecutiveStandard", value = "详细实体emsProductsExecutiveStandard", required = true, dataType = "EmsProductsExecutiveStandard")
    //@RequiresPermissions("emsproductsexecutivestandard:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute EmsProductsExecutiveStandard model){
        model.setCreateman(JwtUtil.getUseridByToken());
        model.setCreatetime(new Date());
        EmsProductsExecutiveStandard emsProductsExecutiveStandard = emsProductsExecutiveStandardService.add(model);
        return success(emsProductsExecutiveStandard);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "Short")
    //@RequiresPermissions("emsproductsexecutivestandard:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable Short id){
        EmsProductsExecutiveStandard emsProductsExecutiveStandard = emsProductsExecutiveStandardService.getById(id);
        return success(emsProductsExecutiveStandard);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的emsProductsExecutiveStandard信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "Short"),
        @ApiImplicitParam(name = "emsProductsExecutiveStandard", value = "详细实体emsProductsExecutiveStandard", required = true, dataType = "EmsProductsExecutiveStandard")
    })
    //@RequiresPermissions("emsproductsexecutivestandard:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody EmsProductsExecutiveStandard model){
        model.setId(id);
        EmsProductsExecutiveStandard emsProductsExecutiveStandard = emsProductsExecutiveStandardService.modify(model);
        return success(emsProductsExecutiveStandard);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "Short")
    //@RequiresPermissions("emsproductsexecutivestandard:delete")
    @DeleteMapping(value = "/{id}")//Short
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<Short> ids = ListUtils.convertList(list);
			  emsProductsExecutiveStandardService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value="获取树状数据", notes="获取钢产品类型的树形数据")
    @GetMapping(value = "/getTree/")
    public RESTfulResult getTree(@RequestParam HashMap parameters){
        List<EmsProductsExecutiveStandard> lists = emsProductsExecutiveStandardService.queryLike(parameters);
        return success(lists);
    }
    @ApiOperation(value="批量修改数据", notes="批量修改钢产品执行标准数据")
    @PutMapping(value = "/batchupdate", produces  = "application/json;charset=UTF-8")
    public RESTfulResult batchupdate(@RequestBody EmsProductsExecutiveStandard[] models) {
        String userId = JwtUtil.getUseridByToken();
        for (int i = 0; i < models.length; i++) {
            EmsProductsExecutiveStandard model = models[i];
            if (model.getId() == null || model.getId().equals("")) {
                return failed(null, "修改失败。id为空");
            }
            if (model.getProduct() == null || model.getProduct().equals("")) {
                return failed(null, "钢产品类型不能为空");
            }
            if (model.getBrand() == null || model.getBrand().equals("")) {
                return failed(null, "钢种不能为空");
            }
            model.setUpdateman(userId);
            model.setUpdatetime(new Date());
        }
        try {
            if(emsProductsExecutiveStandardService.batchUpdate(Arrays.asList(models))>0){
                return success();
            }
        } catch (Exception e) {
            return failed();
        }
        return failed();
    }
}
